package spApp::Mailer;

use strict;
use MIME::Lite; #for creating the MIMEs with their attachments

# constructor
sub new {
	my $class = shift;
	my $self = {};
	bless $self, $class;
	
	$self->{wa} = shift; #suck in a ref to the webapp for good measure. whatever.
	
	return $self;	
}

sub send_email {
	my $self = shift;
	my $args = shift;
	
	my $to          = $args->{to};
	my $to_name     = $args->{to_name};
	if ($to_name) { $to .= " ($to_name)"; } #nice formatty email name-o.
	
	my $subject     = $args->{subject};
	my $text        = $args->{text};
	my $attachments = $args->{attachments}; #array of hashrefs, with keys (type, data, [filename])

	my $from_str = $self->{wa}->param('_config')->{mail_return_address} . '(' . $self->{wa}->param('_config')->{mail_return_name} . ')';
	my $msg = MIME::Lite->new(
			From    => $from_str,
			To      => $to,
			Subject => $subject,
			Type    =>'multipart/mixed'
	);

	$msg->attach(
		Type     =>'TEXT',
		Data     => $text,
	);		


	foreach (@$attachments) {
		$msg->attach(
			Type     => $_->{type},
			Data     => $_->{data},
			Filename => $_->{filename},
		);		
	}

	$msg->add('x-fuckmoney-version', 'subversion 0.1'); #assmolester.
	
	$self->{wa}->ch_debug(['smtp server: ', $self->{wa}->param('_config')->{smtp_server}, $args]);
	$msg->send_by_smtp($self->{wa}->param('_config')->{smtp_server}) or die "Mail error: Some kind of smtp error\n";

	return 1;
}

sub whatever {
	my $self = shift;
	
	my $fail = 1; #pessimistic, no?
	
	if ($fail) { 
		return undef;
	}
	
	return 1;
}	

1;
